/*****************************************************************************
*						œd^ZT[bcrɂ퓔                   *
******************************************************************************
* q[Yݒ AtMega168
* Low: 11100010
*      ||||++++-- CKSEL[3:0] VXeNbNI
*      ||++-- SUT[1:0] N
*      |+-- CKOUT (0:PB0ɃVXeNbNo)
*      +-- CKDIV8 NbNl (1:1/1, 0:1/8)
*
* High:11-10100
*      |||||+++-- BODLEVEL[2:0] (111:, 110:1.8V, 101:2.7V, 100:4.3V)
*      ||||+-- EESAVE (EEPROM 1:, 0:ێ)
*      |||+-- WDTON (1:WDTʏ퓮, 0:WDT펞ON)
*      ||+-- SPIEN (1:ISP֎~, 0:ISP) Parallel̂
*      |+-- DWEN (On-ChipfobO 1:, 0:L)
*      +-- RSTDISBL (RESETs 1:L, 0:(PC6))
*
* Ext: -----001
*           ||+-- BOOTRST f[^V[gQ
*           ++-- BOOTSZ[1:0] f[^V[gQ
*****************************************************************************/
#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include <avr/wdt.h>
#include <avr/pgmspace.h>

/* Cg_				*/
#define TIME_DARK 240						/* }Ȉłoꍇ̃Cg_(b) : max655	*/
#define TIME_IR 120							/* œdZT̃Cg_(b)       : max655	*/

/* ^@臒l					*/
#define THRESHOLD_DAY 90					/*  -> 	*/
#define THRESHOLD_NIGHT 160					/*  -> 	*/
#define THRESHOLD_DARK 150					/*  -> 	*/

/* C^[o`				*/
#define INTERVAL_CDS 20						/* CDS|[OԊu 10msecP							*/

/* A/Dϊϒlobt@		*/
#define ADBUFFER_COUNT 32

/* 7SEG 					*/
#define DOT_ON()   { PORTC &= ~_BV(PC4); }
#define DOT_OFF()  { PORTC |=  _BV(PC4); }
#define SEG_OFF		10
#define SEG_BAR		11
#define SEG_H		12

/* [						*/
#define RL_ON()   { PORTB |=  _BV(PB0); }
#define RL_OFF()  { PORTB &= ~_BV(PB0); }

/* œdZT[					*/
#define IR_INPUT() ( !(PIND & _BV(PD0)) )	/* 0:OFF !0:ON			*/

/* Timer2 }N				*/
/* F/1024 : 10msecŔrv		*/
#define TIMER2_INIT() {	TCCR2B = 0;	TCNT2 = 0; OCR2A = OCR2B = 78; TCCR2B = 7; }

/* [Jϐ錾					*/
volatile uint16_t lightOffCountDown = 0;		/* Cg܂ł̃JEg_E(10msecP)	*/
volatile uint16_t adBuffer[ADBUFFER_COUNT];		/* adϊlόvZpobt@					*/
volatile uint8_t flagNight = 0;					/* 0: 1:									*/

/* [J֐vg^Cv錾		*/
static void hardwareInit( void );
static void lightON( uint16_t time );
static void displayNumber( uint8_t val );

/*****************************************************************************
*						Timer0(8Bit)ɂ7SEG\
*
*****************************************************************************/
ISR( TIMER0_OVF_vect )
{
	static uint8_t blinkCount = 0;
	static uint8_t blink = 0;
	uint16_t t = lightOffCountDown;

	wdt_reset();

	/* uNϐ							*/
	if ( ++blinkCount >= 10 ) {
		blinkCount = 0;
		blink ^= 1;
	}

	/* hbg\								*/
	if ( blink ) {
		DOT_ON();
	} else {
		DOT_OFF();
	}

	/* _̏ꍇ͎c莞ԁij\		*/
	/* ̏ꍇ̓uN^̏ꍇ͓_\	*/
	if ( t ) {										/* Cg_H		*/
		uint8_t min = (uint8_t)( ( ( t / 100 ) + 59 ) / 60 );
		if ( flagNight == 0 ) {						/* H					*/
			if ( blink == 0 ) {
				displayNumber( min );
			} else {
				displayNumber( SEG_OFF );
			}
		} else {									/* H					*/
			displayNumber( min );
		}

	/* ̏ꍇ̏						*/
	} else {
		if ( flagNight ) {
			displayNumber( SEG_BAR );
		} else if ( IR_INPUT() ) {
			displayNumber( SEG_H );
		} else {
			displayNumber( SEG_OFF );
		}
	}
}

/*****************************************************************************
*						Timer1(16Bit)ɂCDSĎ
*****************************************************************************/
ISR( SIG_OUTPUT_COMPARE1A )
{
	uint16_t ad;
	uint16_t avg = 0;

	/* CDŠʂA/Dϊ				*/
	ADCSRA |= _BV(ADSC);
	while ( !( ADCSRA & _BV(ADIF) ) );
	ad = ADC;

	/* E锻						*/
	if ( flagNight == 0 ) {
		if ( ad >= THRESHOLD_NIGHT ) {
			flagNight = 1;
		}
	} else {
		if ( ad <= THRESHOLD_DAY ) {
			flagNight = 0;
			for ( uint8_t i = 0 ;i < ADBUFFER_COUNT ;i++ ) {
				adBuffer[i] = ad;
			}
		}
	}

	/* CDŠʂ̕ϒlvZ			*/
	for ( uint8_t i = 1 ;i < ADBUFFER_COUNT ;i++ ) {
		adBuffer[ i - 1 ] = adBuffer[ i ];
		avg += adBuffer[ i ];
	}
	adBuffer[ ADBUFFER_COUNT - 1 ] = ad;
	avg += ad;
	avg /= ( ADBUFFER_COUNT - 1 );

	/* CDŠʂ̕ϒlvZ			*/
	if ( ( lightOffCountDown == 0 ) && ( flagNight != 0 ) ) {
		/* }Ȉłoꍇ̏		*/
		if ( ad > avg ) {
			if ( ( ad - avg ) >= THRESHOLD_DARK ) {
				lightON( TIME_DARK );
			}
		}
	}

	/* ̊荞݃^C~O	*/
	OCR1A += OCR1B;
}

/*****************************************************************************
*			Timer2(8Bit)ɂ郉CgJEg_E(10msec)
*
*****************************************************************************/
ISR( SIG_OUTPUT_COMPARE2A )
{
	/* Cg_̏ꍇ̓JEg_E		*/
	if ( lightOffCountDown != 0 ) {
		lightOffCountDown--;
	}

	/* JEg_EȈꍇ荞݋֎~	*/
	if ( !lightOffCountDown) {
		TIMSK2 &= ~_BV(OCIE2A);
		RL_OFF();
		for ( uint8_t i = 0 ;i < ADBUFFER_COUNT ;i++ ) {
			adBuffer[i] = 1023;
		}
	}

	/* ̊荞݃^C~O	*/
	OCR2A += OCR2B;
}

/*****************************************************************************
*@				PCINT16(PD0)ω荞݂ɂœdZT[Ď
*****************************************************************************/
ISR( SIG_PIN_CHANGE2 )
{
	/* ŃCgɃ[VZT[	*/
	if ( flagNight && !lightOffCountDown && IR_INPUT() ) {
		lightON( TIME_IR );
	}
}

/*****************************************************************************
*								n[hEGA
* Fvoid
* ߒlFvoid
*****************************************************************************/
static void hardwareInit( void )
{
	/* d̓Jbg											*/
	ACSR = _BV(ACD);							/* AiORp[^d͒~	*/
	SMCR = 0b0001;								/* AChL				*/

	/*  PortB +--------7: Pullup : N.C.                                         */
	/*        |+-------6: Pullup : N.C.                                         */
	/*        ||+------5: Pullup : N.C.                                         */
	/*        |||+-----4: Pullup : N.C.                                         */
	/*        ||||+----3: Pullup : N.C.                                         */
	/*        |||||+---2: Pullup : N.C.                                         */
	/*        ||||||+--1: Pullup : N.C.                                         */
	/*        |||||||+-0: Out(L) : [ 0:OFF 1:ON							*/
	DDRB  = 0b00000001;
	PORTB = 0b11111110;

	/*  PortC +--------7: ---                                                   */
	/*        |+-------6: ---                                                   */
	/*        ||+------5: Out(H) : #7seg                                        */
	/*        |||+-----4: Out(H) : #7seg                                        */
	/*        ||||+----3: Out(H) : #7seg                                        */
	/*        |||||+---2: Out(H) : #7seg                                        */
	/*        ||||||+--1: Out(H) : #7seg                                        */
	/*        |||||||+-0: In     : A/D Input from CDS                           */
	DDRC  = 0b00111110;
	PORTC = 0b11111110;

	/*  PortD +--------7: Out(H) : #7seg                                        */
	/*        |+-------6: Out(H) : #7seg                                        */
	/*        ||+------5: Out(H) : #7seg                                        */
	/*        |||+-----4: Pullup : N.C.                                         */
	/*        ||||+----3: Pullup : N.C                                          */
	/*        |||||+---2: Pullup : N.C                                          */
	/*        ||||||+--1: Pullup : N.C                                          */
	/*        |||||||+-0: Pullup : IR Input                                     */
	DDRD  = 0b11100000;
	PORTD = 0b11111111;

	/* A/Dϊ(PC0)					*/
	ADMUX = _BV(REFS1) | _BV(REFS0);				/* Ch0 : Vref2.56V : Erbg	*/
	DIDR0 = _BV(0);									/* A/Dϊ|[gfW^͋֎~	*/
	ADCSRA  = _BV(ADPS2) | _BV(ADPS1) | _BV(ADPS0) | _BV(ADEN);

	/* PCINT16(PD0)荞ݏ			*/
	PCICR = _BV(PCIE2);
	PCMSK2 = _BV(PCINT16);

	/* Timer0(8bit)(32msec)			*/
	TCNT0 = 0;
	TIMSK0 = _BV(TOIE0);								/* I[o[t[荞ݗL	*/
	TCCR0B = 5;											/* F_CPU / 1024					*/

	/* Timer1(16bit)(250msec)		*/
	TCNT1 = 0;
	OCR1A = OCR1B = (uint16_t)( ( F_CPU * (uint32_t)INTERVAL_CDS ) / 102400L );
	TIMSK1 = _BV(OCIE1A);								/* rv荞ݗL	*/
	TCCR1B = 5;											/* F_CPU / 1024			*/

	/* Timer2(8bit)(10msec)			*/
	TIMER2_INIT();

	/* EIb`hbNݒ					*/
	wdt_enable( WDTO_1S );
}

/*****************************************************************************
*								[nm
* Fuint16_t time ONԁibjő655b
* ߒlFvoid
*****************************************************************************/
static void lightON( uint16_t time )
{
	/* JEg_E荞݋֎~				*/
	TIMSK2 &= ~_BV(OCIE2A);

	/* w̎ԁibj10msecPʂɊZ		*/
	if ( time > 655 ) {
		time = 655;
	}
	time *= 100;

	/* ݂̃^C}[l傫ꍇ̂݃Zbg	*/
	if ( lightOffCountDown < time ) {
		lightOffCountDown = time;					/* JEg_E^C}[Zbg	*/
		RL_ON();									/* [ON						*/
		TIMER2_INIT();								/* Timer2					*/
	}

	/* JEg_E荞݋				*/
	TIMSK2 |= _BV(OCIE2A);
}

/*****************************************************************************
*							7SEG \
* Fuint8_t val 0 ` 9 / SEG_OFF / SEG_BAR
* ߒlFvoid
*****************************************************************************/
static void displayNumber( uint8_t val )
{
	static const prog_uint8_t tbl_pc[] = { 0x00 ,0x24 ,0x28 ,0x20 ,0x04 ,0x02 ,0x02 ,0x00 ,0x00 ,0x00 ,0x2e ,0x2e ,0x04 };
	static const prog_uint8_t tbl_pd[] = { 0x40 ,0xe0 ,0x00 ,0x20 ,0xa0 ,0x20 ,0x00 ,0xe0 ,0x00 ,0x20 ,0xe0 ,0xa0 ,0x80 };
	PORTC = ( PORTC & 0xd1 ) | pgm_read_byte( &tbl_pc[val] );
	PORTD = ( PORTD & 0x1f ) | pgm_read_byte( &tbl_pd[val] );
}

/*****************************************************************************
*								C֐
*****************************************************************************/
int main( void )
{
	/* 							*/
	hardwareInit();

	/* A/Dϊobt@			*/
	for ( uint8_t i = 1 ;i < ADBUFFER_COUNT ;i++ ) {
		ADCSRA |= _BV(ADSC);
		while ( !( ADCSRA & _BV(ADIF) ) );
		adBuffer[i] = ADC;
	}

	/* O[oC^vgL		*/
	sei();

	/* C[v						*/
	while ( 1 ) {
		wdt_reset();
		asm("sleep");								/* ACh			*/
	}

	return ( 0 );
}
